#!/usr/bin/ruby -Ks
#
require '/opt/yklook/swing'

class Bingo < YKLookMain

	def yki_size()
		return [160, 350]
	end

	def yki_title()
		return 'rS'
	end

	def yki_make_display()

		@bingoTable = []
		yk_var( '@bingoTable' )

		panBase  = YKLookPanelBox.new( 'v' )
		panReset = YKLookPanelFlow.new( 'LEFT' )
		panRange = YKLookPanelFlow.new( 'LEFT' )
		panBingo = YKLookPanelFlow.new( 'LEFT' )
		panHist  = YKLookPanelFlow.new( 'LEFT' )
		btnReset = YKLookButton.new( 'Zbg' )
		labelFr  = YKLookLabel.new( 'P' )
		txtLimit = YKLookTextField.new( 5 ).yk_set_tag('limit')
		labelTo  = YKLookLabel.new( '܂' )
		strutVer = YKLookBoxFiller.new( 0, 12 )
		btnBingo = YKLookButton.new( 'rS' )
		labelHit = YKLookLabel.new( '     ' ).yk_set_tag('hit')
		textHist = YKLookTextArea.new( 10, 8 ).yk_set_tag('hist')

		btnReset.yk_set_tooltip( 'w肳ꂽ͈͂̐o悤ɁAׂĂ̐ݒZbg' )
		txtLimit.yk_set_tooltip( 'PȏA1000ȉ̐' )
		btnBingo.yk_set_tooltip( 'w肳ꂽ͈͂̐̒烉_ɑIт' )
		labelHit.yk_set_tooltip( 'rS̐\' )
		textHist.yk_set_tooltip( 'sڂ͍őlBȍ~ArS̗̐\' )
		textHist.yk_set_editable( false )

		panReset.yk_add( btnReset )
		panRange.yk_add( labelFr  )
		panRange.yk_add( txtLimit )
		panRange.yk_add( labelTo  )
		panBingo.yk_add( btnBingo )
		panBingo.yk_add( labelHit )
		panHist.yk_add( textHist )
		panBase.yk_add( panReset )
		panBase.yk_add( strutVer )
		panBase.yk_add( panRange )
		panBase.yk_add( strutVer )
		panBase.yk_add( panBingo )
		panBase.yk_add( panHist )
		yk_add( panBase )

		btnReset.yk_set_listener( :fn_reset )
		btnBingo.yk_set_listener( :fn_bingo )
	end

	def fn_reset( prm_event )
		num = yk_look('limit').yk_text().to_i()
		if num < 1 or 1000 < num
			yk_show_dialog_message( nil, 'PȏA1000ȉ̐͂Ă' )
			return
		end
		@bingoTable.clear()

		for idx in 1..num
			@bingoTable << idx
		end

		yk_look('hit' ).yk_set_text('     ')
		yk_look('hist').yk_set_text('(' + num.to_s() + ")\n")
	end
	def fn_bingo( prm_event )
		if @bingoTable.size() < 1
			if yk_look('hist').yk_text().length() == 0
				yk_show_dialog_message( nil,
									'w肵āuZbgv{^Ă')
			else
				yk_show_dialog_message( nil, 'ׂďI܂' )
			end
		end
		idx = rand( @bingoTable.size() )
		num = @bingoTable.delete_at( idx ).to_s()
		yk_look('hit' ).yk_set_text( num )
		yk_look('hist').yk_append_text( num + "\n" )
	end

	def yki_laf_is_system()
		return false
	end
	# def yki_fr_need_pack()
	#	return true
	# end
	# def yki_ht_farpath()
	#	return [ '/tools' , nil ]
	#end
end

YKLookMain.yk_mainloop( Bingo.new() )

#
# end of program
